org.apache.hc.core5.http.nio.support

## Class BasicRequestConsumer<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.BasicRequestConsumer<T>

- Type Parameters:
    `T` - The message body type.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncRequestConsumer<Message<HttpRequest,T>>, ResourceHolder

      public class BasicRequestConsumer<T>
      extends Object
      implements AsyncRequestConsumer<Message<HttpRequest,T>>

  Basic implementation of `AsyncRequestConsumer` that represents the request message as a `Message` and relies on a `AsyncEntityConsumer` to process request entity stream.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicRequestConsumer(AsyncEntityConsumer<T> dataConsumer)`
    `BasicRequestConsumer(Supplier<AsyncEntityConsumer<T>> dataConsumerSupplier)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeRequest(HttpRequest request, EntityDetails entityDetails, HttpContext httpContext, FutureCallback<Message<HttpRequest,T>> resultCallback)` Triggered to signal receipt of a request message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicRequestConsumer

          public BasicRequestConsumer(Supplier<AsyncEntityConsumer<T>> dataConsumerSupplier)

    - #### BasicRequestConsumer

          public BasicRequestConsumer(AsyncEntityConsumer<T> dataConsumer)

  - ### Method Detail

    - #### consumeRequest

          public void consumeRequest(HttpRequest request,
                                     EntityDetails entityDetails,
                                     HttpContext httpContext,
                                     FutureCallback<Message<HttpRequest,T>> resultCallback)
                              throws HttpException,
                                     IOException

      Description copied from interface: `AsyncRequestConsumer`
      Triggered to signal receipt of a request message head.
      Specified by:
        `consumeRequest` in interface `AsyncRequestConsumer<Message<HttpRequest,T>>`
      Parameters:
        `request` - the request message head.
        `entityDetails` - the request entity details or `null` if the request does not enclose an entity.
        `httpContext` - the actual execution context.
        `resultCallback` - the result callback called when request processing has been completed successfully or unsuccessfully.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)
                         throws HttpException,
                                IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncRequestConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncRequestConsumer<Message<HttpRequest,T>>`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.